from autopilot.testcase import AutopilotTestCase
from autopilot.introspection.gtk import GtkIntrospectionTestMixin
from autopilot.matchers import Eventually
from testtools.matchers import Equals, NotEquals, GreaterThan, LessThan, Contains

from time import sleep
import tempfile
import os

#Register Shotwell as an application so we can call it
AutopilotTestCase.register_known_application("Shotwell", "shotwell.desktop", "shotwell")

#http://packages.qa.ubuntu.com/qatracker/testcases/1428/info

class GtkToolbarTests(AutopilotTestCase, GtkIntrospectionTestMixin):
     
    def setUp(self):
        #Open Shotwell
        super(GtkToolbarTests, self).setUp()
        self.app = self.launch_test_application('shotwell')

    def test_import_pictures(self):
        #Test-case name: shotwell/swp-001
        #This test will check that Shotwell can import pictures from camera
        
       # Plug in your camera using a USB cable. Your camera may need to be switched on, check the camera manual
        _pluginCamera()
        sleep(15)        
        
        #Select 'shotwell' in the dropdown and click ok
        
        #TODO this does not work as the window is not always focused
        #if  I can focus the window then I can close it
        #self.keyboard.press_and_release("Alt+o")
                
        #Verify that Shotwell is open   
        #LibraryWindow
        windowTitle = self.app.select_single('LibraryWindow', title='Shotwell')
        self.assertThat(windowTitle.title, Eventually(Equals('Shotwell')))
        
        #Shotwell loads and displays thumbnails of the photos on your camera   
        #LibraryWindow, GtkBox, GtkPaned, GtkFrame, GtkAlignment, BasicProperties
        rowsCols = self.app.select_single('BasicProperties')
        self.assertThat(rowsCols.n_rows, Eventually(GreaterThan(1)))
        self.assertThat(rowsCols.n_columns, Eventually(GreaterThan(1)))

       # Select a single photo and click Import Selected (to make it simple I import all the photos)
        #self.keyboard.press_and_release("Alt+f")
        #sleep(1)
        #self.keyboard.press_and_release("a")
        #sleep(1)
        #self.keyboard.type("\n")
        #sleep(5)
        
        #Library, GtkBox, GtkPaned, GtkFrame, Gtkbox, GtkToolbar, GtkToolButton
        btn = self.app.select_single('GtkToolButton', label='Import_All')
        #does it exist?
        self.assertThat(btn, NotEquals(None))
        #let's click it
        self.mouse.move_to_object(btn)
        self.mouse.click()
    
       #Shotwell imports the photo and displays a prompt asking you if you wish to delete the photos from the camera    
       #Select no.
       # press Alt+k to keep photos on camera
        self.keyboard.press_and_release("Alt+k")
 
        #Select 'last import' in the left hand pane
        
          
        #Close Shotwell and exit    
        _closeAndExit()
        sleep(5)


def _pluginCamera():
        # display message to warn tester to plugin an switch on camera
        os.system("zenity --info --text 'Close this window, plug in and switch on your camera '")
        


def _closeAndExit():
     #Close open window gvfs-udisks2-volume-monitor
     os.system("zenity --info --text 'Swtich off camera '")

